base/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path
from drf_spectacular.views import SpectacularAPIView, SpectacularSwaggerView

api_patterns = [
    path("public/", include("api.public.urls")),
    path("schema/", SpectacularAPIView.as_view(), name="schema"),
    path("docs/", SpectacularSwaggerView.as_view(), name="swagger-ui"),
]

urlpatterns = [
    path(f"{settings.BASE_URL}admin/", admin.site.urls),
    path(f"{settings.BASE_URL}api/", include(api_patterns)),
    path(f"{settings.BASE_URL}auth/", include("authentication.urls")),
    path(f"{settings.BASE_URL}submit/", include("submitter.urls")),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns.append(path("__debug__/", include("debug_toolbar.urls")))

submitter/urls.py
from django.contrib.auth.decorators import login_required
from django.urls import path

from .api_validation_views import (
    ValidateChebiName,
    ValidateSynonym,
    HtmxSubmitCompoundGetSources,
    GetChemicalDataFromMol,
    GetMassFromFormula,
    SpeciesSearch,
    ComponentSearch,
    GetSourceAccessionField,
)
from .views.profile import SubmitterHomeView, SubmitterProfileView
from .views.retrieve_compound import SubmitterEntityDetailView, SubmitterEntityListView
from .views.submit_compound import SubmitCompoundView
from .views.update_compound import (
    NamesUpdateView,
    HtmxUpdateCompoundGetSourceView,
    SubmitterCreateNameView,
    CompoundUpdateView,
    SubmitterCreateCrossReferenceView,
    SubmitterUpdateCrossReferenceView,
)

app_name = "submitter"

# All submitter views require login
# TODO: Can we move login_required decorator to base.urls?
urlpatterns = [
    path("", login_required(SubmitterHomeView.as_view()), name="dashboard"),
    path("new/", login_required(SubmitCompoundView.as_view()), name="submit-new"),
    path("profile/", login_required(SubmitterProfileView.as_view()), name="profile"),
    path("CHEBI:<pk>/", login_required(SubmitterEntityDetailView.as_view()), name="entity-detail"),
    path("CHEBI:<pk>/edit/", login_required(CompoundUpdateView.as_view()), name="edit-entity"),
    path("name/<pk>/update/", login_required(NamesUpdateView.as_view()), name="name-update"),
    path("CHEBI:<pk>/add-synonym/", login_required(SubmitterCreateNameView.as_view()), name="add-synonym"),
    path("CHEBI:<pk>/add-xref/", login_required(SubmitterCreateCrossReferenceView.as_view()), name="add-xref"),
    path("xref/<pk>/edit/", login_required(SubmitterUpdateCrossReferenceView.as_view()), name="update-xref"),
    path("my-submissions/", login_required(SubmitterEntityListView.as_view()), name="my-submissions"),
    # HTMX Views
    path("validate/name/", login_required(ValidateChebiName.as_view()), name="validate_chebi_name"),
    path(
        "validate/source/<str:form_type>/",
        login_required(HtmxSubmitCompoundGetSources.as_view()),
        name="validate_source",
    ),
    path("validate/synonym/", login_required(ValidateSynonym.as_view()), name="validate_synonym"),
    path(
        "validate/mol_to_chemical_data/", login_required(GetChemicalDataFromMol.as_view()), name="mol_to_chemical_data"
    ),
    path("validate/formula_to_mass/", login_required(GetMassFromFormula.as_view()), name="formula_to_mass"),
    path("validate/species/", login_required(SpeciesSearch.as_view()), name="species_search"),
    path("validate/component/", login_required(ComponentSearch.as_view()), name="component_search"),
    path(
        "validate/source_accession/",
        login_required(GetSourceAccessionField.as_view()),
        name="get_source_accession_field",
    ),
    path("htmx/get/source/", login_required(HtmxUpdateCompoundGetSourceView.as_view()), name="htmx_get_source"),
]

templates/submitter/compound-update/xref/create_xref.html
{% extends "base.html" %}
{% load static %}
{% block title %}ChEBI:{{ form.compound_id }} | Add XRef{% endblock %}
{% block page_heading %}Add Cross Reference{% endblock %}

{% block content %}
    <div>
    <h6 class="text-center">Add new manual cross-reference to CHEBI:{{ form.compound_id }}</h6>
    </div>
    <form method="post" class="m-5">
        {% csrf_token %}
        {{ form }}

        <div class="row justify-content-center mt-3">
            <div class="col-auto">
                <a class="btn btn-danger" href="{% url 'submitter:entity-detail' pk=form.compound_id %}">Cancel</a>
                <button type="submit" class="btn btn-success">Submit</button>
            </div>
        </div>
    </form>
{% endblock %}

{% block script %}
    <script src="{% static 'js/htmx.min.js' %}" defer></script>
{% endblock %}

templates/submitter/compound-update/xref/update_xref.html
{% extends "base.html" %}
{% load static %}
{% block title %}ChEBI:{{ form.instance.compound_id }} | Edit XRef{% endblock %}
{% block page_heading %}Update Cross Reference{% endblock %}

{% block content %}
    <div>
    <h6 class="text-center">Update cross-reference for CHEBI:{{ form.instance.compound_id }}</h6>
    </div>
    <form method="post" class="m-5">
        {% csrf_token %}
        {{ form }}

        <div class="row justify-content-center mt-3">
            <div class="col-auto">
                <a class="btn btn-danger" href="{% url 'submitter:entity-detail' pk=form.instance.compound_id %}">Cancel</a>
                {% if can_edit %}
                    <button type="submit" class="btn btn-success">Submit</button>
                {% endif %}
            </div>
        </div>
    </form>
{% endblock %}

{% block script %}
    <script src="{% static 'js/htmx.min.js' %}" defer></script>
{% endblock %}